# Generating a configuration file

Each simulation is run based on a configuration file, in the form of a .json file. One can repeat the experiment based on the same configuration file several times. Note that the configuration file contains the (random) topology and the (random) costs on the edges of the topology.

To generate one or several configuration files (saved as .json files), one can use the script `create_configuration.py` located at `SRC/SCRIPTS/`. The script expect simulation parameters in the form of `parameter=value`, for example:

```
python3 SRC/SCRIPTS/create_configuration.py number_nodes=10 limit_turns=10000 selfish=0.8 status=COST width=500 height=500 max_value=10 filename=toto
```

Will create a configuration file named `toto.json`.

Valid parameters are:
- `number_nodes`: the number of nodes in the simulation
- `limit_turns`: the maximum number of turns of the simulation
- `selfish`: the selfishness of each node (real number from 0 to 1) 
- `status`: the criterium used for improving a node value, can be `COST`, `EFFICIENT`, or `TIME`  
- `width`: the width of the area where nodes are randomly located
- `height`: the height of the area where nodes are randomly located
- `max_value`: the maximum cost of an edge
- `filename`: the name of the file to store the configuration when saved

# Running the simulator 

Running one instance of the simulation consists in running the .jar file obtained from the Java source code and providing the configuration file name on the command line. For example:

```
java -jar network-creation-game.jar toto.json
```

By default, the simulator will run in visual mode, providing a graphical representation of the network topology as it evolves, with a 2 seconds delay between each change. When running a simulation campain, one want to run several times the same simulation as fast as possible, it is thus useful to specify that no graphical interface should be displayed. For this purpose, one should add the `FALSE` keywork on the command line. For example:

```
java -jar network-creation-game.jar toto.json FALSE
```

Each run of the simulator writes two log files:
- `log__XX` contains unformatted log
- `rawData__XX.json` contains each step of the simulation formatted in JSON

# Decoding raw output of the simulator

Once the `rawData__XX.json` has been obtained, it shall be reformatted by the help of the `decode_output.py` script as follows:

```
python3 SRC/SCRIPTS/decode_output.py rawData__XX.json output.json
```

Where `output.json` denotes the name of the correctly formatted output of the simulator.

# Generating initial and final topologies graphs

Using the configuration file and the correctly formatted output file, one can generate the initial and final topologies obtained as PNG graphic files using the `show_topology.py` script:

```
python3 SRC/SCRIPTS/show_topology.py toto.json output.json
```

Where `toto.json` is the configuration file used for the simulation, and where `output.json` is the correctly formatted output generated by the `decode_output.py` script. This should generate two PNG files:
- `toto.json_initial_topology.png`
- `output.json_final_topology.png`
